/*==================================================================================================
*   Project              : RTD AUTOSAR 4.4
*   Platform             : CORTEXM
*   Peripheral           : FLEXCAN
*   Dependencies         : 
*
*   Autosar Version      : 4.4.0
*   Autosar Revision     : ASR_REL_4_4_REV_0000
*   Autosar Conf.Variant :
*   SW Version           : 0.9.0
*   Build Version        : S32K3_RTD_0_9_0__ASR_REL_4_4_REV_0000_20210326
*
*   (c) Copyright 2020 - 2021 NXP Semiconductors
*   All Rights Reserved.
*
*   NXP Confidential. This software is owned or controlled by NXP and may only be
*   used strictly in accordance with the applicable license terms. By expressly
*   accepting such terms or by downloading, installing, activating and/or otherwise
*   using the software, you are agreeing that you have read, and that you agree to
*   comply with and are bound by, such license terms. If you do not agree to be
*   bound by the applicable license terms, then you may not retain, install,
*   activate or otherwise use the software.
==================================================================================================*/
/***********************************************************************************************************************
 * This file was generated by the S32 Configuration Tools. Any manual edits made to this file
 * will be overwritten if the respective S32 Configuration Tools is used to update this file.
 **********************************************************************************************************************/

#ifdef __cplusplus
extern "C"{
#endif

/*==================================================================================================
*                                        INCLUDE FILES
* 1) system and project includes
* 2) needed interfaces from external units
* 3) internal and external interfaces from this unit
==================================================================================================*/
#include "FlexCAN_Ip_Sa_BOARD_InitPeripherals_PBcfg.h"
#include "FlexCAN_Ip_Types.h"
#if (FEATURE_CAN_HAS_DMA_ENABLE == STD_ON)
    #include "Dma_Ip.h"
#endif
/*==================================================================================================
*                              SOURCE FILE VERSION INFORMATION
==================================================================================================*/
#define FLEXCAN_IP_VENDOR_ID_BOARD_InitPeripherals_PBCFG_C 43
#define FLEXCAN_IP_AR_RELEASE_MAJOR_VERSION_BOARD_InitPeripherals_PBCFG_C 4
#define FLEXCAN_IP_AR_RELEASE_MINOR_VERSION_BOARD_InitPeripherals_PBCFG_C 4
#define FLEXCAN_IP_AR_RELEASE_REVISION_VERSION_BOARD_InitPeripherals_PBCFG_C 0
#define FLEXCAN_IP_SW_MAJOR_VERSION_BOARD_InitPeripherals_PBCFG_C 0
#define FLEXCAN_IP_SW_MINOR_VERSION_BOARD_InitPeripherals_PBCFG_C 9
#define FLEXCAN_IP_SW_PATCH_VERSION_BOARD_InitPeripherals_PBCFG_C 0
/*==================================================================================================
*                                     FILE VERSION CHECKS
==================================================================================================*/
/* TODO: */

/*==================================================================================================
*                                   GLOBAL FUNCTION PROTOTYPES
==================================================================================================*/
#define CAN_START_SEC_CODE
#include "Can_MemMap.h"

#define CAN_STOP_SEC_CODE
#include "Can_MemMap.h"
/*==================================================================================================
*                                GLOBAL VARIABLE DECLARATIONS
==================================================================================================*/
#define CAN_START_SEC_VAR_INIT_UNSPECIFIED
#include "Can_MemMap.h"
/* FlexCAN State Structure used By driver
User should not modify this structure */
Flexcan_Ip_StateType FlexCAN_State0;
#define CAN_STOP_SEC_VAR_INIT_UNSPECIFIED
#include "Can_MemMap.h"
/*==================================================================================================
*                                      GLOBAL CONSTANTS
==================================================================================================*/
#define CAN_START_SEC_CONFIG_DATA_UNSPECIFIED
#include "Can_MemMap.h"

const Flexcan_Ip_ConfigType FlexCAN_Config0  = {
    /* Number Of Message Buffer used .max_num_mb  */
    (uint8)16,
    /*Can Hw filter count* .num_id_filters*- aici exista variatna sa generez toate filtrele si sa referentiezi tu in cod */
    FLEXCAN_RX_FIFO_ID_FILTERS_8,
    /* Legacy FIFO ENABLED .is_rx_fifo_needed*/
    (boolean)FALSE,
#if (FEATURE_CAN_HAS_ENHANCED_RX_FIFO == STD_ON)
    /* The number of standard ID filter elements */
    0U,
    /* The number of extended ID filter elements */
    2U,
    /* The number of enhanced Rx FIFO watermark */
    0U,
    /* The Enhanced Rx FIFO feature is enabled or not. */
    (boolean)FALSE,
#endif
#if (FEATURE_CAN_HAS_HR_TIMER == STD_ON)
    /* TimeStamp Structure Configuration */
    {
        /* timeStampSurce Timer Source */
        FLEXCAN_CAN_CLK_TIMESTAMP_SRC,
        /* msgBuffTimeStampType Timestamp MB Type  */
        FLEXCAN_MSGBUFFTIMESTAMP_TIMER,
        /* hrConfigType Timestamp HR capture configuration */
        FLEXCAN_TIMESTAMPCAPTURE_DISABLE,
        /* hrSrc HT Timer Source */
        FLEXCAN_HRTIMERSRC_GMAC,
    },
#endif
    FLEXCAN_NORMAL_MODE,
     /*ctrlOptions*/
    (uint32)(\
    \
    0U),
     /* Can FD RamBlock specified *//*.payload*/
    {
      FLEXCAN_PAYLOAD_SIZE_8,
      FLEXCAN_PAYLOAD_SIZE_8,
      FLEXCAN_PAYLOAD_SIZE_8
    },
        /*Can FD enabled .fd_enable*/
        (boolean)FALSE,
        /*Enhance CBT support . extCbtEnable*/
        (boolean)FALSE,
        /*BRS for FD .bitRateSwitch*/
        (boolean)FALSE,
        /*values for normal baudrate .bitrate*/
        {   /* Prop Seg */
            (6U),
            /* Phase Seg 1 */
            (5U),
            /* Phase Seg 2*/
            (1U),
            /* Pre Divider */
            (5U),
            /* Resync jump width */
            (1U)
        },
            /*values for FD baudrate .bitrate*/
        {   /* Prop Seg */
            (7U),
            /* Phase Seg 1 */
            (4U),
            /* Phase Seg 2*/
            (0U),
            /* Pre Divider */
            (3U),
            /* Resync jump width */
            (0U)
        },
        /*transfer_type*/
        FLEXCAN_RXFIFO_USING_INTERRUPTS,
#if (FEATURE_CAN_HAS_DMA_ENABLE == STD_ON)
     /* DMA channel number used for transfers. */
        ,
  #endif
    /* Controller Callback */
    NULL_PTR,
    /* Error Callback */
    NULL_PTR
    };
    
#define CAN_STOP_SEC_CONFIG_DATA_UNSPECIFIED
#include "Can_MemMap.h"

#ifdef __cplusplus
}
#endif
/** @} */

